Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/RectangularIdenticalBinPackingProblem.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/RectangularIdenticalBinPackingProblem.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/RectangularIdenticalBinPackingProblem.cs	(revision 14048)
@@ -38,5 +38,5 @@
   [Creatable(CreatableAttribute.Categories.CombinatorialProblems, Priority = 300)]
   // TODO: only support 2d BPPData
-  public class RectangularIdenticalBinPackingProblem : BinPackingProblem<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem>, IProblemInstanceConsumer<BPPData>, IProblemInstanceExporter<BPPData> {
+  public class RectangularIdenticalBinPackingProblem : BinPackingProblem<PackingPosition, RectangularPackingShape, RectangularPackingItem>, IProblemInstanceConsumer<BPPData>, IProblemInstanceExporter<BPPData> {
 
     #region Default Instance
@@ -97,5 +97,5 @@
     }
     public RectangularIdenticalBinPackingProblem() : base(
-      new PackingPlanEvaluationAlgorithm<Permutation, TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem>()) {
+      new PackingPlanEvaluationAlgorithm<Permutation, PackingPosition, RectangularPackingShape, RectangularPackingItem>()) {
     }
 
@@ -174,6 +174,6 @@
     protected override void RemoveTooBigItems() {
       PackingItemMeasures.RemoveAll(pi =>
-        !PackingBinMeasures.Encloses(new TwoDimensionalPacking(0, 0, 0, false), pi) &&
-        !PackingBinMeasures.Encloses(new TwoDimensionalPacking(0, 0, 0, true), pi));
+        !PackingBinMeasures.Encloses(new PackingPosition(0, 0, 0, false), pi) &&
+        !PackingBinMeasures.Encloses(new PackingPosition(0, 0, 0, true), pi));
     }
     #endregion
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/RectangularPackingShape.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/RectangularPackingShape.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/RectangularPackingShape.cs	(revision 14048)
@@ -32,5 +32,5 @@
   [Item("RectangularPackingShape", "Represents the rectangular measures (width, height) of a two-dimensional bin-packing object.")]
   [StorableClass]
-  public class RectangularPackingShape : PackingShape<TwoDimensionalPacking>, IComparable<RectangularPackingShape> {
+  public class RectangularPackingShape : PackingShape<PackingPosition>, IComparable<RectangularPackingShape> {
     public int Height {
       get { return ((IFixedValueParameter<IntValue>)Parameters["Height"]).Value.Value; }
@@ -86,8 +86,8 @@
 
     #region Helpers
-    public override TwoDimensionalPacking Origin { get { return new TwoDimensionalPacking(0, 0, 0); } }
+    public override PackingPosition Origin { get { return new PackingPosition(0, 0, 0); } }
     public override int Volume { get { return Height * Width; } }
 
-    public override bool EnclosesPoint(TwoDimensionalPacking myPosition, TwoDimensionalPacking checkedPoint) {
+    public override bool EnclosesPoint(PackingPosition myPosition, PackingPosition checkedPoint) {
       return (myPosition.X <= checkedPoint.X &&
                 (myPosition.X + (myPosition.Rotated ? Height : Width) - 1) >= checkedPoint.X &&
@@ -95,8 +95,8 @@
                 (myPosition.Y + (myPosition.Rotated ? Width : Height) - 1) >= checkedPoint.Y);
     }
-    public override bool Encloses(TwoDimensionalPacking checkedPosition, PackingShape<TwoDimensionalPacking> checkedShape) {
+    public override bool Encloses(PackingPosition checkedPosition, PackingShape<PackingPosition> checkedShape) {
       return Encloses(checkedPosition, (RectangularPackingShape)checkedShape);
     }
-    private bool Encloses(TwoDimensionalPacking checkedPosition, RectangularPackingShape checkedShape) {
+    private bool Encloses(PackingPosition checkedPosition, RectangularPackingShape checkedShape) {
       return Encloses(new RectangleDiagonal(this), new RectangleDiagonal(checkedPosition, checkedShape));
     }
@@ -108,8 +108,8 @@
     }
 
-    public override bool Overlaps(TwoDimensionalPacking myPosition, TwoDimensionalPacking checkedPosition, PackingShape<TwoDimensionalPacking> checkedShape) {
+    public override bool Overlaps(PackingPosition myPosition, PackingPosition checkedPosition, PackingShape<PackingPosition> checkedShape) {
       return Overlaps(myPosition, checkedPosition, (RectangularPackingShape)checkedShape);
     }
-    private bool Overlaps(TwoDimensionalPacking myPosition, TwoDimensionalPacking checkedPosition, RectangularPackingShape checkedShape) {
+    private bool Overlaps(PackingPosition myPosition, PackingPosition checkedPosition, RectangularPackingShape checkedShape) {
       return Overlaps(new RectangleDiagonal(myPosition, this), new RectangleDiagonal(checkedPosition, checkedShape));
     }
@@ -136,6 +136,6 @@
       public int x2;
       public int y2;
-      public RectangleDiagonal(RectangularPackingShape myShape) : this(new TwoDimensionalPacking(0, 0, 0), myShape) { }
-      public RectangleDiagonal(TwoDimensionalPacking myPosition, RectangularPackingShape myShape) {
+      public RectangleDiagonal(RectangularPackingShape myShape) : this(new PackingPosition(0, 0, 0), myShape) { }
+      public RectangleDiagonal(PackingPosition myPosition, RectangularPackingShape myShape) {
         x1 = myPosition.X;
         y1 = myPosition.Y;
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Solution.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Solution.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Solution.cs	(revision 14048)
@@ -28,5 +28,5 @@
   [Item("Bin Packing Solution (2d)", "Represents a solution for a 2D bin packing problem.")]
   [StorableClass]
-  public class Solution : PackingPlan<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem> {
+  public class Solution : PackingPlan<PackingPosition, RectangularPackingShape, RectangularPackingItem> {
     public Solution(RectangularPackingShape binMeasures) : this(binMeasures, false, false) { }
     public Solution(RectangularPackingShape binMeasures, bool useExtremePoints, bool stackingConstraints) : base(binMeasures, useExtremePoints, stackingConstraints) { }
@@ -39,5 +39,5 @@
       return new Solution(this, cloner);
     }
-    public override BinPacking<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem> NewBinPacking() {
+    public override BinPacking<PackingPosition, RectangularPackingShape, RectangularPackingItem> NewBinPacking() {
       return new BinPacking2D(BinMeasures);
     }
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.3D/3.3/BinPacking3D.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.3D/3.3/BinPacking3D.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.3D/3.3/BinPacking3D.cs	(revision 14048)
@@ -30,9 +30,9 @@
   [Item("BinPacking3D", "Represents a single-bin packing for a 3D bin-packing problem.")]
   [StorableClass]
-  public class BinPacking3D : BinPacking<ThreeDimensionalPacking, CuboidPackingShape, CuboidPackingItem> {
+  public class BinPacking3D : BinPacking<PackingPosition, CuboidPackingShape, CuboidPackingItem> {
 
     public BinPacking3D(CuboidPackingShape binMeasures)
       : base(binMeasures) {
-      ExtremePoints = new SortedSet<ThreeDimensionalPacking>(new EPComparer3D());
+      ExtremePoints = new SortedSet<PackingPosition>(new EPComparer3D());
       ExtremePoints.Add(binMeasures.Origin);
     }
@@ -42,5 +42,5 @@
       : base(original, cloner) {
       this.depthWasDoubled = original.depthWasDoubled;
-      this.ExtremePoints = new SortedSet<ThreeDimensionalPacking>(original.ExtremePoints, new EPComparer3D());
+      this.ExtremePoints = new SortedSet<PackingPosition>(original.ExtremePoints, new EPComparer3D());
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -48,30 +48,30 @@
     }
 
-    protected override void GenerateNewExtremePointsForNewItem(CuboidPackingItem newItem, ThreeDimensionalPacking position) {
+    protected override void GenerateNewExtremePointsForNewItem(CuboidPackingItem newItem, PackingPosition position) {
       int newWidth = position.Rotated ? newItem.Depth : newItem.Width;
       int newDepth = position.Rotated ? newItem.Width : newItem.Depth;
 
       //Find ExtremePoints beginning from sourcepointX
-      var sourcePointX = new ThreeDimensionalPacking(0, position.X + newWidth, position.Y, position.Z);
+      var sourcePointX = new PackingPosition(0, position.X + newWidth, position.Y, position.Z);
       if (sourcePointX.X < BinMeasures.Width && sourcePointX.Y < BinMeasures.Height && sourcePointX.Z < BinMeasures.Depth) {
         //Traversing down the y-axis  
-        ThreeDimensionalPacking current = new ThreeDimensionalPacking(0, sourcePointX.X, sourcePointX.Y, sourcePointX.Z);
-        while (current.Y > 0 && !IsPointOccupied(ThreeDimensionalPacking.MoveDown(current))) {
-          current = ThreeDimensionalPacking.MoveDown(current);
-        }
-        ExtremePoints.Add((ThreeDimensionalPacking)current.Clone());
-        while (current.X > 0 && !IsPointOccupied(ThreeDimensionalPacking.MoveLeft(current))) {
-          current = ThreeDimensionalPacking.MoveLeft(current);
+        PackingPosition current = new PackingPosition(0, sourcePointX.X, sourcePointX.Y, sourcePointX.Z);
+        while (current.Y > 0 && !IsPointOccupied(PackingPosition.MoveDown(current))) {
+          current = PackingPosition.MoveDown(current);
+        }
+        ExtremePoints.Add((PackingPosition)current.Clone());
+        while (current.X > 0 && !IsPointOccupied(PackingPosition.MoveLeft(current))) {
+          current = PackingPosition.MoveLeft(current);
         }
         ExtremePoints.Add(current);
 
         //Traversing down the z-axis
-        current = new ThreeDimensionalPacking(0, sourcePointX.X, sourcePointX.Y, sourcePointX.Z);
-        while (current.Z > 0 && !IsPointOccupied(ThreeDimensionalPacking.MoveBack(current))) {
-          current = ThreeDimensionalPacking.MoveBack(current);
-        }
-        ExtremePoints.Add((ThreeDimensionalPacking)current.Clone());
-        while (current.Y > 0 && !IsPointOccupied(ThreeDimensionalPacking.MoveDown(current))) {
-          current = ThreeDimensionalPacking.MoveDown(current);
+        current = new PackingPosition(0, sourcePointX.X, sourcePointX.Y, sourcePointX.Z);
+        while (current.Z > 0 && !IsPointOccupied(PackingPosition.MoveBack(current))) {
+          current = PackingPosition.MoveBack(current);
+        }
+        ExtremePoints.Add((PackingPosition)current.Clone());
+        while (current.Y > 0 && !IsPointOccupied(PackingPosition.MoveDown(current))) {
+          current = PackingPosition.MoveDown(current);
         }
         ExtremePoints.Add(current);
@@ -82,25 +82,25 @@
 
       //Find ExtremePoints beginning from sourcepointY
-      var sourcePointY = new ThreeDimensionalPacking(0, position.X, position.Y + newItem.Height, position.Z);
+      var sourcePointY = new PackingPosition(0, position.X, position.Y + newItem.Height, position.Z);
       if (sourcePointY.X < BinMeasures.Width && sourcePointY.Y < BinMeasures.Height && sourcePointY.Z < BinMeasures.Depth) {
         //Traversing down the x-axis          
-        ThreeDimensionalPacking current = new ThreeDimensionalPacking(0, sourcePointY.X, sourcePointY.Y, sourcePointY.Z);
-        while (current.X > 0 && !IsPointOccupied(ThreeDimensionalPacking.MoveLeft(current))) {
-          current = ThreeDimensionalPacking.MoveLeft(current);
-        }
-        ExtremePoints.Add((ThreeDimensionalPacking)current.Clone());
-        while (current.Y > 0 && !IsPointOccupied(ThreeDimensionalPacking.MoveDown(current))) {
-          current = ThreeDimensionalPacking.MoveDown(current);
+        PackingPosition current = new PackingPosition(0, sourcePointY.X, sourcePointY.Y, sourcePointY.Z);
+        while (current.X > 0 && !IsPointOccupied(PackingPosition.MoveLeft(current))) {
+          current = PackingPosition.MoveLeft(current);
+        }
+        ExtremePoints.Add((PackingPosition)current.Clone());
+        while (current.Y > 0 && !IsPointOccupied(PackingPosition.MoveDown(current))) {
+          current = PackingPosition.MoveDown(current);
         }
         ExtremePoints.Add(current);
 
         //Traversing down the z-axis                                                                   
-        current = new ThreeDimensionalPacking(0, sourcePointY.X, sourcePointY.Y, sourcePointY.Z);
-        while (current.Z > 0 && !IsPointOccupied(ThreeDimensionalPacking.MoveBack(current))) {
-          current = ThreeDimensionalPacking.MoveBack(current);
-        }
-        ExtremePoints.Add((ThreeDimensionalPacking)current.Clone());
-        while (current.Y > 0 && !IsPointOccupied(ThreeDimensionalPacking.MoveDown(current))) {
-          current = ThreeDimensionalPacking.MoveDown(current);
+        current = new PackingPosition(0, sourcePointY.X, sourcePointY.Y, sourcePointY.Z);
+        while (current.Z > 0 && !IsPointOccupied(PackingPosition.MoveBack(current))) {
+          current = PackingPosition.MoveBack(current);
+        }
+        ExtremePoints.Add((PackingPosition)current.Clone());
+        while (current.Y > 0 && !IsPointOccupied(PackingPosition.MoveDown(current))) {
+          current = PackingPosition.MoveDown(current);
         }
         ExtremePoints.Add(current);
@@ -112,25 +112,25 @@
 
       //Find ExtremePoints beginning from sourcepointZ
-      var sourcePointZ = new ThreeDimensionalPacking(0, position.X, position.Y, position.Z + newDepth);
+      var sourcePointZ = new PackingPosition(0, position.X, position.Y, position.Z + newDepth);
       if (sourcePointZ.X < BinMeasures.Width && sourcePointZ.Y < BinMeasures.Height && sourcePointZ.Z < BinMeasures.Depth) {
         //Traversing down the x-axis                                                                             
-        ThreeDimensionalPacking current = new ThreeDimensionalPacking(0, sourcePointZ.X, sourcePointZ.Y, sourcePointZ.Z);
-        while (current.X > 0 && !IsPointOccupied(ThreeDimensionalPacking.MoveLeft(current))) {
-          current = ThreeDimensionalPacking.MoveLeft(current);
-        }
-        ExtremePoints.Add((ThreeDimensionalPacking)current.Clone());
-        while (current.Y > 0 && !IsPointOccupied(ThreeDimensionalPacking.MoveDown(current))) {
-          current = ThreeDimensionalPacking.MoveDown(current);
+        PackingPosition current = new PackingPosition(0, sourcePointZ.X, sourcePointZ.Y, sourcePointZ.Z);
+        while (current.X > 0 && !IsPointOccupied(PackingPosition.MoveLeft(current))) {
+          current = PackingPosition.MoveLeft(current);
+        }
+        ExtremePoints.Add((PackingPosition)current.Clone());
+        while (current.Y > 0 && !IsPointOccupied(PackingPosition.MoveDown(current))) {
+          current = PackingPosition.MoveDown(current);
         }
         ExtremePoints.Add(current);
 
         //Traversing down the y-axis                                                                     
-        current = new ThreeDimensionalPacking(0, sourcePointZ.X, sourcePointZ.Y, sourcePointZ.Z);
-        while (current.Y > 0 && !IsPointOccupied(ThreeDimensionalPacking.MoveDown(current))) {
-          current = ThreeDimensionalPacking.MoveDown(current);
-        }
-        ExtremePoints.Add((ThreeDimensionalPacking)current.Clone());
-        while (current.X > 0 && !IsPointOccupied(ThreeDimensionalPacking.MoveLeft(current))) {
-          current = ThreeDimensionalPacking.MoveLeft(current);
+        current = new PackingPosition(0, sourcePointZ.X, sourcePointZ.Y, sourcePointZ.Z);
+        while (current.Y > 0 && !IsPointOccupied(PackingPosition.MoveDown(current))) {
+          current = PackingPosition.MoveDown(current);
+        }
+        ExtremePoints.Add((PackingPosition)current.Clone());
+        while (current.X > 0 && !IsPointOccupied(PackingPosition.MoveLeft(current))) {
+          current = PackingPosition.MoveLeft(current);
         }
         ExtremePoints.Add(current);
@@ -146,5 +146,5 @@
     }
 
-    public override ThreeDimensionalPacking FindExtremePointForItem(CuboidPackingItem measures, bool rotated, bool stackingConstraints) {
+    public override PackingPosition FindExtremePointForItem(CuboidPackingItem measures, bool rotated, bool stackingConstraints) {
 
       CuboidPackingItem item = new CuboidPackingItem(
@@ -164,5 +164,5 @@
       if (epIndex < ExtremePoints.Count) {
         var origPoint = ExtremePoints.ElementAt(epIndex);
-        var result = new ThreeDimensionalPacking(origPoint.AssignedBin, origPoint.X, origPoint.Y, origPoint.Z, rotated);
+        var result = new PackingPosition(origPoint.AssignedBin, origPoint.X, origPoint.Y, origPoint.Z, rotated);
         return result;
       }
@@ -170,26 +170,26 @@
     }
 
-    public override ThreeDimensionalPacking FindPositionBySliding(CuboidPackingItem measures, bool rotated) {
+    public override PackingPosition FindPositionBySliding(CuboidPackingItem measures, bool rotated) {
       //Starting-position at upper right corner (=left bottom point of item-rectangle is at position item.width,item.height)
-      ThreeDimensionalPacking currentPosition = new ThreeDimensionalPacking(0,
+      PackingPosition currentPosition = new PackingPosition(0,
         BinMeasures.Width - (rotated ? measures.Depth : measures.Width),
         BinMeasures.Height - measures.Height,
         BinMeasures.Depth - (rotated ? measures.Width : measures.Depth), rotated);
       //Slide the item as far as possible to the bottom
-      while (IsPositionFeasible(measures, ThreeDimensionalPacking.MoveDown(currentPosition))
-        || IsPositionFeasible(measures, ThreeDimensionalPacking.MoveLeft(currentPosition))
-        || IsPositionFeasible(measures, ThreeDimensionalPacking.MoveBack(currentPosition))) {
+      while (IsPositionFeasible(measures, PackingPosition.MoveDown(currentPosition))
+        || IsPositionFeasible(measures, PackingPosition.MoveLeft(currentPosition))
+        || IsPositionFeasible(measures, PackingPosition.MoveBack(currentPosition))) {
         //Slide the item as far as possible to the left
-        while (IsPositionFeasible(measures, ThreeDimensionalPacking.MoveLeft(currentPosition))
-      || IsPositionFeasible(measures, ThreeDimensionalPacking.MoveBack(currentPosition))) {
+        while (IsPositionFeasible(measures, PackingPosition.MoveLeft(currentPosition))
+      || IsPositionFeasible(measures, PackingPosition.MoveBack(currentPosition))) {
           //Slide the item as far as possible to the back
-          while (IsPositionFeasible(measures, ThreeDimensionalPacking.MoveBack(currentPosition))) {
-            currentPosition = ThreeDimensionalPacking.MoveBack(currentPosition);
+          while (IsPositionFeasible(measures, PackingPosition.MoveBack(currentPosition))) {
+            currentPosition = PackingPosition.MoveBack(currentPosition);
           }
-          if (IsPositionFeasible(measures, ThreeDimensionalPacking.MoveLeft(currentPosition)))
-            currentPosition = ThreeDimensionalPacking.MoveLeft(currentPosition);
-        }
-        if (IsPositionFeasible(measures, ThreeDimensionalPacking.MoveDown(currentPosition)))
-          currentPosition = ThreeDimensionalPacking.MoveDown(currentPosition);
+          if (IsPositionFeasible(measures, PackingPosition.MoveLeft(currentPosition)))
+            currentPosition = PackingPosition.MoveLeft(currentPosition);
+        }
+        if (IsPositionFeasible(measures, PackingPosition.MoveDown(currentPosition)))
+          currentPosition = PackingPosition.MoveDown(currentPosition);
       }
 
@@ -242,5 +242,5 @@
     }
 
-    public override int ShortestPossibleSideFromPoint(ThreeDimensionalPacking position) {
+    public override int ShortestPossibleSideFromPoint(PackingPosition position) {
 
       int shortestSide = int.MaxValue;
@@ -252,18 +252,18 @@
         return shortestSide;
 
-      ThreeDimensionalPacking current = new ThreeDimensionalPacking(0, position.X, position.Y, position.Z);
-      while (current.X < width && IsPointOccupied(current)) { current = ThreeDimensionalPacking.MoveRight(current); }
+      PackingPosition current = new PackingPosition(0, position.X, position.Y, position.Z);
+      while (current.X < width && IsPointOccupied(current)) { current = PackingPosition.MoveRight(current); }
       if (current.X - position.X < shortestSide)
         shortestSide = current.X - position.X;
 
 
-      current = new ThreeDimensionalPacking(0, position.X, position.Y, position.Z);
-      while (current.Y < height && IsPointOccupied(current)) { current = ThreeDimensionalPacking.MoveUp(current); }
+      current = new PackingPosition(0, position.X, position.Y, position.Z);
+      while (current.Y < height && IsPointOccupied(current)) { current = PackingPosition.MoveUp(current); }
       if (current.Y - position.Y < shortestSide)
         shortestSide = current.Y - position.Y;
 
 
-      current = new ThreeDimensionalPacking(0, position.X, position.Y, position.Z);
-      while (current.Z < depth && IsPointOccupied(current)) { current = ThreeDimensionalPacking.MoveFront(current); }
+      current = new PackingPosition(0, position.X, position.Y, position.Z);
+      while (current.Z < depth && IsPointOccupied(current)) { current = PackingPosition.MoveFront(current); }
       if (current.Z - position.Z < shortestSide)
         shortestSide = current.Z - position.Z;
@@ -271,13 +271,13 @@
       return shortestSide;
     }
-    public override bool IsStaticStable(CuboidPackingItem item, ThreeDimensionalPacking position) {
+    public override bool IsStaticStable(CuboidPackingItem item, PackingPosition position) {
       //Static stability is given, if item is placed on the ground
       if (position.Y == 0)
         return true;
 
-      if (IsPointOccupied(new ThreeDimensionalPacking(0, position.X, position.Y - 1, position.Z))
-        && IsPointOccupied(new ThreeDimensionalPacking(0, position.X + item.Width - 1, position.Y - 1, position.Z))
-        && IsPointOccupied(new ThreeDimensionalPacking(0, position.X, position.Y - 1, position.Z + item.Depth - 1))
-        && IsPointOccupied(new ThreeDimensionalPacking(0, position.X + item.Width - 1, position.Y - 1, position.Z + item.Depth - 1)))
+      if (IsPointOccupied(new PackingPosition(0, position.X, position.Y - 1, position.Z))
+        && IsPointOccupied(new PackingPosition(0, position.X + item.Width - 1, position.Y - 1, position.Z))
+        && IsPointOccupied(new PackingPosition(0, position.X, position.Y - 1, position.Z + item.Depth - 1))
+        && IsPointOccupied(new PackingPosition(0, position.X + item.Width - 1, position.Y - 1, position.Z + item.Depth - 1)))
         return true;
 
@@ -304,5 +304,5 @@
 
     [Storable]
-    private bool depthWasDoubled = false;
+    private bool depthWasDoubled = false; // TODO ???
     public void DoubleDepth() {
       if (!depthWasDoubled) {
@@ -314,5 +314,5 @@
     }
 
-    public bool IsSupportedByAtLeastOnePoint(CuboidPackingItem item, ThreeDimensionalPacking position) {
+    public bool IsSupportedByAtLeastOnePoint(CuboidPackingItem item, PackingPosition position) {
       if (position.Y == 0)
         return true;
@@ -321,17 +321,17 @@
       for (int x = position.X; x < position.X + item.Width; x++)
         for (int z = position.Z; z < position.Z + item.Depth; z++)
-          if (IsPointOccupied(new ThreeDimensionalPacking(0, x, y, z)))
+          if (IsPointOccupied(new PackingPosition(0, x, y, z)))
             return true;
 
       return false;
     }
-    public bool IsWeightSupported(CuboidPackingItem item, ThreeDimensionalPacking ep) {
+    public bool IsWeightSupported(CuboidPackingItem item, PackingPosition ep) {
       if (ep.Y == 0)
         return true;
 
-      if (ItemMeasures[PointOccupation(new ThreeDimensionalPacking(0, ep.X, ep.Y - 1, ep.Z))].SupportsStacking(item)
-        && ItemMeasures[PointOccupation(new ThreeDimensionalPacking(0, ep.X + item.Width - 1, ep.Y - 1, ep.Z))].SupportsStacking(item)
-        && ItemMeasures[PointOccupation(new ThreeDimensionalPacking(0, ep.X, ep.Y - 1, ep.Z + item.Depth - 1))].SupportsStacking(item)
-        && ItemMeasures[PointOccupation(new ThreeDimensionalPacking(0, ep.X + item.Width - 1, ep.Y - 1, ep.Z + item.Depth - 1))].SupportsStacking(item))
+      if (ItemMeasures[PointOccupation(new PackingPosition(0, ep.X, ep.Y - 1, ep.Z))].SupportsStacking(item)
+        && ItemMeasures[PointOccupation(new PackingPosition(0, ep.X + item.Width - 1, ep.Y - 1, ep.Z))].SupportsStacking(item)
+        && ItemMeasures[PointOccupation(new PackingPosition(0, ep.X, ep.Y - 1, ep.Z + item.Depth - 1))].SupportsStacking(item)
+        && ItemMeasures[PointOccupation(new PackingPosition(0, ep.X + item.Width - 1, ep.Y - 1, ep.Z + item.Depth - 1))].SupportsStacking(item))
         return true;
 
@@ -345,5 +345,5 @@
       }
     }
-    protected override void AddNewItemToOccupationLayers(int itemID, CuboidPackingItem measures, ThreeDimensionalPacking position) {
+    protected override void AddNewItemToOccupationLayers(int itemID, CuboidPackingItem measures, PackingPosition position) {
       int z1 = position.Z / 10;
       int z2 = (position.Z + (position.Rotated ? measures.Width : measures.Depth)) / 10;
@@ -352,8 +352,8 @@
         OccupationLayers[i].Add(itemID);
     }
-    protected override List<int> GetLayerItemIDs(ThreeDimensionalPacking position) {
+    protected override List<int> GetLayerItemIDs(PackingPosition position) {
       return OccupationLayers[position.Z / 10];
     }
-    protected override List<int> GetLayerItemIDs(CuboidPackingItem measures, ThreeDimensionalPacking position) {
+    protected override List<int> GetLayerItemIDs(CuboidPackingItem measures, PackingPosition position) {
       List<int> result = new List<int>();
       int z1 = position.Z / 10;
@@ -366,6 +366,6 @@
     }
   }
-  public class EPComparer3D : IComparer<ThreeDimensionalPacking> {
-    public int Compare(ThreeDimensionalPacking a, ThreeDimensionalPacking b) {
+  public class EPComparer3D : IComparer<PackingPosition> {
+    public int Compare(PackingPosition a, PackingPosition b) {
       int result = a.Z.CompareTo(b.Z);
       if (result == 0)
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.3D/3.3/CuboidIdenticalBinPackingProblem.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.3D/3.3/CuboidIdenticalBinPackingProblem.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.3D/3.3/CuboidIdenticalBinPackingProblem.cs	(revision 14048)
@@ -38,5 +38,5 @@
   [Creatable(CreatableAttribute.Categories.CombinatorialProblems, Priority = 310)]
   // TODO don't support generic BPPData but only 3d BPPData
-  public class CuboidIdenticalBinPackingProblem : BinPackingProblem<ThreeDimensionalPacking, CuboidPackingShape, CuboidPackingItem>, IProblemInstanceConsumer<BPPData>, IProblemInstanceExporter<BPPData> {
+  public class CuboidIdenticalBinPackingProblem : BinPackingProblem<PackingPosition, CuboidPackingShape, CuboidPackingItem>, IProblemInstanceConsumer<BPPData>, IProblemInstanceExporter<BPPData> {
 
 
@@ -102,5 +102,5 @@
     }
     public CuboidIdenticalBinPackingProblem() : base(
-      new PackingPlanEvaluationAlgorithm<Permutation, ThreeDimensionalPacking, CuboidPackingShape, CuboidPackingItem>()) {
+      new PackingPlanEvaluationAlgorithm<Permutation, PackingPosition, CuboidPackingShape, CuboidPackingItem>()) {
     }
 
@@ -178,6 +178,6 @@
     protected override void RemoveTooBigItems() {
       PackingItemMeasures.RemoveAll(pi =>
-        !PackingBinMeasures.Encloses(new ThreeDimensionalPacking(0, 0, 0, 0, false), pi) &&
-        !PackingBinMeasures.Encloses(new ThreeDimensionalPacking(0, 0, 0, 0, true), pi));
+        !PackingBinMeasures.Encloses(new PackingPosition(0, 0, 0, 0, false), pi) &&
+        !PackingBinMeasures.Encloses(new PackingPosition(0, 0, 0, 0, true), pi));
     }
     #endregion
